<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_Board ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_Board extends AbstractStructArrayBase
{
    /**
     * The Board
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_Board[]
     */
    public $Board;
    /**
     * Constructor method for ArrayOfJP_Board
     * @uses ArrayOfJP_Board::setBoard()
     * @param \StructType\JP_Board[] $board
     */
    public function __construct(array $board = array())
    {
        $this
            ->setBoard($board);
    }
    /**
     * Get Board value
     * @return \StructType\JP_Board[]|null
     */
    public function getBoard()
    {
        return $this->Board;
    }
    /**
     * Set Board value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Board[] $board
     * @return \ArrayType\ArrayOfJP_Board
     */
    public function setBoard(array $board = array())
    {
        foreach ($board as $arrayOfJP_BoardBoardItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_BoardBoardItem instanceof \StructType\JP_Board) {
                throw new \InvalidArgumentException(sprintf('The Board property can only contain items of \StructType\JP_Board, "%s" given', is_object($arrayOfJP_BoardBoardItem) ? get_class($arrayOfJP_BoardBoardItem) : gettype($arrayOfJP_BoardBoardItem)), __LINE__);
            }
        }
        $this->Board = $board;
        return $this;
    }
    /**
     * Add item to Board value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Board $item
     * @return \ArrayType\ArrayOfJP_Board
     */
    public function addToBoard(\StructType\JP_Board $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_Board) {
            throw new \InvalidArgumentException(sprintf('The Board property can only contain items of \StructType\JP_Board, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Board[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_Board|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_Board|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_Board|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_Board|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_Board|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Board
     */
    public function getAttributeName()
    {
        return 'Board';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_Board
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
